# pro-archman
# src/output.sh
# Functions for printing messages
#
# Copyright (C) 2013  Patrick McDermott
#
# This file is part of the ProteanOS Archive Manager.
#
# The ProteanOS Archive Manager is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Archive Manager is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Archive Manager.  If not, see
# <http://www.gnu.org/licenses/>.

error()
{
	local status=${1}
	local fmt="${2}"
	shift 2

	printf '%s: Error: ' "${0##*/}" 1>&2
	printf "${fmt}\n" "${@}" 1>&2

	# In a subshell, this will have no effect, so the shell's exit status
	# will be 128+SIGINT.  Meh.
	exit_status=${status}
	kill -s INT ${$}
}

warn()
{
	local fmt="${1}"
	shift 1

	printf '%s: Warning: ' "${0##*/}" 1>&2
	printf "${fmt}\n" "${@}" 1>&2

	return 0
}

info()
{
	local fmt="${1}"
	shift 1

	printf '%s: ' "${0##*/}" 1>&2
	printf "${fmt}\n" "${@}" 1>&2

	return 0
}

info_v()
{
	if ${opt_v:-false} || ${conf_verbose:-false}; then
		info "${@}"
		return ${?}
	fi

	return 0
}
